/*! Parental Control V2.18 */
class ParentalControl {
    constructor() {
        this.currentUrl = window.location.href;
    }

    injectCSS() {
        let style = document.createElement("link");
        style.rel = "stylesheet";
        style.type = "text/css";
        style.href = chrome.extension.getURL("assets/css/content.css");
        (document.head || document.documentElement).appendChild(style);
    }

    parseUrl(url) {
        let a = document.createElement('a');
        a.href = url;
        return a;
    }

    getDomain(url) {
        if (url === null)
            return url;
        return this.parseUrl(url).hostname
    }

    getParameterByName(name, url) {
        if (!url)
            url = window.location.href;
        name = name.replace(/[\[\]]/g, "\\$&");
        let regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"), results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return "";
        return decodeURIComponent(results[2].replace(/\+/g, " "));
    }

    tempMask(is_blockable) {
        let id = "parentalcontrol";
        let mask = "none";
        if (is_blockable === "true" || is_blockable === true)
            mask = "true";

        if (document.getElementById(id)) {
            let blockerOverlay = document.getElementById(id);
            blockerOverlay.style.display = mask;
        } else {
            chrome.extension.sendMessage({
                message: "blockSite", url: this.currentUrl, reason: "disclaimer"
            });

        }
    }

    checkTitle() {
        let title = document.title;
        if (title.length > 0) {
            chrome.extension.sendMessage({message: "keywords", value: title, url: this.currentUrl});
        }
    }

    checkDisclaimer() {
        let disclaimerCl = document.getElementsByClassName("disclaimer"),
            disclaimerId = document.getElementById("disclaimer");

        if (disclaimerId) {
            if (disclaimerId.innerText.indexOf("18 years or older") !== -1 || disclaimerId.innerText.indexOf("18+") !== -1) {
                chrome.extension.sendMessage({
                    message: "blockSite", url: this.currentUrl, reason: "disclaimer"
                });
            }
        }
        if (disclaimerCl && disclaimerCl.length > 0) {
            if (disclaimerCl[0].innerText.indexOf("18 years or older") !== -1 || disclaimerCl[0].innerText.indexOf("18+") !== -1) {
                chrome.extension.sendMessage({
                    message: "blockSite",
                    url: this.currentUrl,
                    reason: "disclaimer"
                });
            }
        }
    }

    checkContent() {

    }

    checkAgeRestriction() {
        let query = "//body[";
        query += "contains(., 'age-restricted')";
        query += " or ";
        query += "contains(., 'Warning: This Site Contains Sexually Explicit Content')";
        query += " or ";
        query += "contains(., ' contains adult material')";
        query += " or ";
        query += "contains(., 'website contains adult material')";
        query += " or ";
        query += "contains(., 'ADULTS ONLY DISCLAIMER')";
        query += " or ";
        query += "contains(., 'Warning: You must be 18 years or older')";
        query += " or ";
        query += "contains(., 'adult-only')";

        query += " or ";
        query += "contains(., 'porn')";
        query += " or ";
        query += "contains(., 'fuck')";
        query += " or ";
        query += "contains(., 'sex')";
        query += " or ";
        query += "contains(., 'трахн')";
        query += " or ";
        query += "contains(., 'lgbt')";
        query += " or ";
        query += "contains(., 'seks')";


        query += "]";
        let headings = document.evaluate(query, document, null, XPathResult.ANY_TYPE, null),
            thisHeading = headings.iterateNext();
        if (thisHeading) {
            let textContent = thisHeading.textContent;
            if (textContent) {
                textContent = textContent.toLowerCase();
                if (textContent.indexOf("porn") !== -1
                    || textContent.indexOf("sex") !== -1
                    || textContent.indexOf("adult") !== -1

                ) {
                    chrome.extension.sendMessage({
                        message: "blockSite",
                        url: this.currentUrl,
                        reason: "age-restriced"
                    });
                }
            }
        }
    }

    checkMetaTags() {
        let metaTags = document.querySelectorAll("meta");

        for (let i = 0; i < metaTags.length; i++) {
            let meta = metaTags[i],
                key = meta.attributes[0].nodeValue.toLowerCase();

            switch (key) {
                case "keywords":
                case "description":
                case "og:description":
                case "og:title": {
                    let value = String(meta.attributes.getNamedItem("content").value).toLowerCase();
                    if (value.length === 0) return;
                    chrome.extension.sendMessage({
                        message: "keywords",
                        value: value,
                        url: this.currentUrl
                    });
                    break;
                }


                case "pics-label": {
                    let value = meta.attributes[1].nodeValue.toLowerCase();
                    let ratings = value.split("r (")[1].split(")")[0].split(" ");
                    for (let k = 0; k < ratings.length; k++) {
                        let label = ratings[k];
                        if (label === "n" || label == "s") {
                            let rating = parseInt(ratings[k + 1]);
                            if (rating > 0) {
                                chrome.extension.sendMessage({
                                    message: "blockSite",
                                    url: this.currentUrl,
                                    reason: "adult-content-tag"
                                });
                            }
                        }
                    }
                    break;
                }
                case "rating": {
                    let value = meta.attributes[1].nodeValue.toLowerCase();
                    if (value.indexOf("rta") !== -1) {
                        chrome.extension.sendMessage({
                            message: "blockSite",
                            url: this.currentUrl,
                            reason: "RTA tag"
                        });
                    }
                    break;
                }
                case "adult_content": {
                    let value = meta.attributes[1].nodeValue.toLowerCase();
                    if (value.indexOf("mature") !== -1 || value.indexOf("true") !== -1 || value.indexOf("restriced")) {
                        chrome.extension.sendMessage({
                            message: "blockSite",
                            url: this.currentUrl,
                            reason: "adult-content-tag"
                        });
                    }
                    break;
                }

            }
        }
    }

    checkAdultAds() {
        let images = document.querySelectorAll("img");
        if (images.length === 0)
            return;
        let query = "//body[";
        query += "contains(., 'exoclick')";
        query += " or ";
        query += "contains(., 'xxximagetpb')";
        query += " or ";
        query += "contains(., 'juicyads')";
        query += " or ";
        query += "contains(., 'eroticads.com')";
        query += "]";
        let headings = document.evaluate(query, document, null, XPathResult.ANY_TYPE, null),
            thisHeading = headings.iterateNext();
        if (thisHeading) {
            let textContent = thisHeading.textContent;
            if (textContent) {
                textContent = textContent.toLowerCase();
                if (textContent.indexOf("porn") !== -1) {
                    chrome.extension.sendMessage({
                        message: "blockSite",
                        url: this.currentUrl,
                        reason: "erotic-ads"
                    });
                }
            }
        }
    }

    checkAds() {
        let data_asyncs = document.querySelectorAll("*[data-cfasync=false]");
        if (data_asyncs.length > 0) {
            for (let i = 0; i < data_asyncs.length; i++) {
                let data_async = data_asyncs[0];
                data_async.innerText = "";
                data_async.removeAttribute("src");
            }
        }
        let scripts = document.scripts;
        for (let j = 0; j < scripts.length; j++) {
            let script = scripts[j];
            if (script.innerText.indexOf("popunder") !== -1) {
                script.innerText = "";
            }
        }
    }
    checkPopunder() {
        if (typeof popunder !== "undefined") {
        }
        if (typeof _wm_settings !== "undefined") {
        }
    }

    init() {
        let domain = this.getDomain(this.currentUrl);

        chrome.extension.sendMessage({
            message: "isBlockCss",
            domain: domain
        }, function (response) {
            let options = response.options,
                tracker = response.tracker;
            if (options.filters.$ads === 1 && (!tracker || tracker.blocksite == 1)) {
                this.injectCSS();
            }

            if (options.filters.$adult === 1) {
                if (this.currentUrl.indexOf("blocker.html") !== -1 || domain.indexOf("google") !== -1 || domain.indexOf("bing") !== -1 || domain.indexOf("youtube") !== -1 || domain.indexOf("yahoo") !== -1) {
                    this.currentUrl = this.getParameterByName("url");
                    return;
                }
                if (domain.indexOf("porn") !== -1 || domain.indexOf("sex") !== -1 || domain.indexOf("xxx") !== -1 || domain.indexOf("slut") !== -1) {
                    this.tempMask(true);
                    chrome.runtime.sendMessage({message: "isWhite", url: this.currentUrl}, function (response) {
                        if (response) {
                            this.tempMask(false);
                        } else {
                            chrome.extension.sendMessage({
                                message: "blockSite",
                                url: this.currentUrl,
                                reason: "adult domain"
                            });
                        }
                    }.bind(this));
                }

                this.checkTitle();
                this.checkDisclaimer();
                this.checkAgeRestriction();
                this.checkMetaTags();
                this.checkAdultAds();
            }
            if (options.filters.$ads === 1) {
                this.checkAds();
                this.checkPopunder();
            }
        }.bind(this));
    }
}

const pornBlocker = new ParentalControl();

document.addEventListener("DOMContentLoaded", function () {
    pornBlocker.init();
}, true);