/*! Parental Control V2.18 */
class Engines {
    constructor() {
        this.options = {};
    }

    generateIcon(url, isPorn, isSuspicious) {
    }

    responseFunc(response) {
        if (!response)
            return;
        let className = response.anchor,
            index = response.linkIndex,
            elm = document.querySelectorAll(className)[index],
            link = elm;

        if (link.tagName != "A") {
            link = elm.querySelector("a");
        }

        if (link.innerHTML.indexOf("parentalcontrol") !== -1) {
            return;
        }

        let isPorn = response.isPorn,
            isSuspicious = response.isSuspicious,
            iconDiv = this.generateIcon(link.href, isPorn, isSuspicious);

        let orig = link.innerHTML;
        link.innerHTML = orig + iconDiv;

        if (isPorn || isSuspicious && this.options.search.suspicious === 1) {
            let hook = link.href.indexOf("?") !== -1 ? "&" : "?",
                url = link.href + hook + "ptbdw=1";
            link.setAttribute("href", url);
        }
    }

    injectCSS() {
        let style = document.createElement("link");
        style.rel = "stylesheet";
        style.type = "text/css";
        style.href = chrome.extension.getURL("css/engines.css");
        (document.head || document.documentElement).appendChild(style);
    }

    inject(search) {
        let className = "", subclass = "", query = "";
        switch (search) {
            case "bing": {
                className = ".b_algo";
                subclass = ".b_algo";
                query = "b_caption";
                break;
            }
            case "google": {
                className = ".r";
                subclass = ".r";
                query = ".s";
                break;
            }
            case "yahoo": {
                className = ".yschttl";
                subclass = ".algo";
                query = "lh-18";
                break;
            }
        }
        let elms = document.querySelectorAll(className);
        if (elms.length === 0) {
            elms = document.querySelectorAll(subclass);
            className = subclass;
        }
        if (elms.length > 0) {
            for (let i = 0; i < elms.length; i++) {
                let anchor = elms[i];
                if (elms[i].tagName != "A")
                    anchor = elms[i].querySelector("a");
                let label = anchor.innerText,
                    desc = elms[i].parentNode.querySelectorAll(query);
                if (desc && desc.length > 0) {
                    label += " " + desc[0].innerText;
                }

                chrome.extension.sendMessage({ message: "scanLink",  anchor: className,  url: anchor.href,  label: label,  linkIndex: i }, this.responseFunc.bind(this));
            }
        }
    }

    init() {
        let domain = pornBlocker.getDomain(pornBlocker.currentUrl);

        if (domain.indexOf("yahoo.") == -1 && domain.indexOf("bing.com") == -1 && domain.indexOf("google.") == -1) {
            return;
        }
        chrome.extension.sendMessage({message: "getOptions", domain: domain}, function (options) {
            let search = "";
            if (domain.indexOf("yahoo.") != -1) {
                search = "yahoo";
            } else if (domain.indexOf("bing.com") != -1) {
                search = "bing";
            } else if (domain.indexOf("google.") != -1) {
                search = "google";
            }
            if (search === "bing" && options.search.bing === 0 || search === "google" && options.search.google === 0 || search === "yahoo" && options.search.yahoo === 0) {
                return false;
            }

            this.options = options;
            this.injectCSS();

            let mark = "parentalcontrol_item",
                marker = document.querySelector(mark);
            if (marker) {
                return;
            }
            this.inject(search);
            marker = document.createElement("div");
            marker.id = mark;
            document.body.appendChild(marker);
        }.bind(this));
    }

}

const engines = new Engines();

document.addEventListener("DOMContentLoaded", function () {
    engines.init();
}, false);


