/*! Parental Control V2.18 */
class Adult {
    constructor() {
        this.activeTabId = -1;
        this.white = [];
        this.black = [];
        this.matchingWords = [];
        this.blackWords = [];
    }

    checkCookies(cookies) {
        for (let i = 0; i < cookies.length; ++i) {
            if (cookies[i].name === "PREF") {
                let value = cookies[i].value;
                if (value.indexOf("f2=") === -1) {
                    value += "&f2=8000000";
                    chrome.cookies.set({
                        url: "https://.youtube.com/",
                        name: "PREF",
                        value: value
                    });
                    //chrome.tabs.reload(this.activeTabId);
                }
            }
        }
    }

    addWhite(url) {
        for (let i = 0; i < this.white.length; i++) {
            if (this.white[i] === url) return;
        }
        this.white.push(url);
        chrome.storage.local.set({
            white: this.white
        });
    }

    removeWhite(url) {
        for (let i = 0; i < this.white.length; i++) {
            if (this.white[i] === url) {
                this.white.splice(i, 1);
                chrome.storage.local.set({
                    white: this.white
                });
                return;
            }
        }
    }

    isWhiteSite(url) {
        if (url.indexOf('parentalcontrol.site') != -1) {
            return true;
        }

        if (settings.options.filters.$trust === 0) {
            return false;
        }
        for (let j = 0; j < this.white.length; j++) {
            if (url.search(this.white[j]) !== -1) {
                return true;
            }
        }
        return false;
    }

    addBlack(url) {
        if (url.indexOf('chrome.google.com') != -1) {
            return false;
        }

        if (url.indexOf('chrome-extension://') != -1) {
            return;
        }
        if (url.indexOf('parentalcontrol.site') != -1) {
            return false;
        }

        for (let i = 0; i < this.black.length; i++) {
            if (this.black[i] === url) return;
        }
        this.black.push(url);
        chrome.storage.local.set({black: this.black});
    }

    addBlackWords(keyword) {
        for (let i = 0; i < this.blackWords.length; i++) {
            if (this.blackWords[i] === keyword) return;
        }
        this.blackWords.push(keyword);

        chrome.storage.local.set({blackwords: this.blackWords});
    }

    removeBlack(url) {
        for (let i = 0; i < this.black.length; i++) {
            if (this.black[i] === url) {
                this.black.splice(i, 1);
                chrome.storage.local.set({
                    black: this.black
                });
                return;
            }
        }
        for (let j = 0; j < this.blackWords.length; j++) {
            if (this.blackWords[j] === url) {
                this.blackWords.splice(j, 1);
                chrome.storage.local.set({
                    blackWords: this.blackWords
                });
                return;
            }
        }
    }

    isBlackSite(url) {
        if (settings.options.filters.$block === 0) {
            return false;
        }
        for (let j = 0; j < this.black.length; j++) {
            if (url.search(this.black[j]) !== -1) {
                return true;
            }
        }
        return false;
    }

    getSuffix(domain) {
        if (domain === null)
            return domain;
        let idx = domain.lastIndexOf(".");
        let suffix = domain.substring(idx);
        return suffix;
    }

    isSuspiciousDomain(request) {
        let url = request.url;
        let matching = utils.filterItem(api.controller.adult, "domains", url);
        if (matching.value.length > 0) {
            return true;
        }
        return false;
    }

    isSuspiciousWord(word) {
        if (word.length === 0) return false;
        let matchingWords = [];
        let matching = utils.filterItem(api.controller.adult, "words", word, true);
        if (matching.value.length > 0) {
            matchingWords = matchingWords.concat(matching.value);
            matchingWords = matchingWords.unique();
        }
        if (matchingWords.length > 1) {
            return true;
        }
        return false;
    }

    isPornSite(request) {
        if (settings.options.filters.$adult === 0) {
            return false;
        }
        if (!request || request.tabId === -1 || !api.checkUrl(request.url)) {
            return false;
        }
        let url = request.url;

        if (url.search("blocker1.html") !== -1 || url.search("blocker2.html") !== -1 || url.search("blocker3.html") !== -1 || url.search("url=") !== -1) {
            return false;
        }

        if (url.search("ptbdw=1") !== -1) {
            return true;
        }
        for (let i = 0; i < this.white.length; i++) {
            if (url.search(this.white[i]) !== -1) {
                return false;
            }
        }
        let domain = utils.getDomain(url);

        if (url.indexOf('chrome.google.com') != -1) {
            return false;
        }

        if (url.indexOf('chrome-extension://') != -1) {
            return false;
        }
        if (url.indexOf('parentalcontrol.site') != -1) {
            return false;
        }


        if (this.getSuffix(domain) === ".xxx" || this.getSuffix(domain) === ".porn" || this.getSuffix(domain) === ".sex" || this.getSuffix(domain) === ".sexy")
            return true;

        let matching = utils.filterItem(api.controller.adult, "sites", url);
        if (matching.value.length > 0) {
            return true;
        }
        matching = utils.filterItem(api.controller.adult, "domains", url);

        if (matching.value.length > 0) {
            return true;
        }
        this.checkCategorySite(url);
        return false;
    }

    checkCategorySite(domain) {
    }

    blockSite(request, reason) {
        if (settings.options.filters.$adult === 0) {
            return false;
        }
        let url = request.url,
            tabId = request.tabId;
        let tracker = browser.findTrackerByTabId(tabId);

        if (tracker) {
            tracker.adult = 1;
        }
        if (url.indexOf('chrome.google.com') != -1) {
            return false;
        }

        if (url.indexOf('chrome-extension://') != -1) {
            return false;
        }
        if (url.indexOf("blocker1.html") !== -1 || url.indexOf("blocker2.html") !== -1 || url.indexOf("blocker3.html") !== -1 && url.indexOf("url=") !== -1 || url.indexOf(api.blockHost) !== -1) {
            return false;
        }
        let domain = url;

        chrome.storage.local.get(null, function (items) {
            if (items.options.account.style == 1) {
                this.blockHost = chrome.extension.getURL("layouts/blocker1.html?url=");
            }
            if (items.options.account.style == 2) {
                this.blockHost = chrome.extension.getURL("layouts/blocker2.html?url=");
            }
            if (items.options.account.style == 3) {
                this.blockHost = chrome.extension.getURL("layouts/blocker3.html?url=");
            }
            let newUrl = this.blockHost + domain;

            if (reason !== "user") {
                newUrl = this.blockHost + domain;
            }
            try {
                console.log('update')
                chrome.tabs.update(tabId, {url: newUrl});
            } catch (e) {
                console.log('update')
                chrome.tabs.update({url: newUrl});
            }
            browser.updateButton(2);
        }.bind(this))


    }

    onMessage(request, sender, sendResponse) {
        switch (request.message) {
            case "getWhite": {
                sendResponse(this.white);
                break;
            }
            case "getBlack": {
                let black = this.black.concat(this.blackWords);
                sendResponse(black);
                break;
            }
            case "removeFromList": {
                let cat = request.cat;
                if (cat == "trust") {
                    this.removeWhite(request.url);
                } else {
                    this.removeBlack(request.url);
                }
                break;
            }
            case "isWhite": {
                let url = request.url;
                sendResponse(this.isWhiteSite(url));
                break
            }
            case "addToWhiteList": {
                this.removeBlack(request.url);
                this.addWhite(request.url);
                if (settings.options.account.require === 1) {
                    try {

                    } catch (ex) {
                    }
                }
                sendResponse(1);
                console.log('addToWhiteList')
                if (request.tab) {
                    console.log(request.tab)
                    //chrome.tabs.reload(request.tab);
                }
                break;
            }
            case "addToBlackList": {
                this.removeWhite(request.url);
                this.addBlack(request.url);
                console.log('addToBlackList')

                if (request.tab) {
                    chrome.tabs.reload(request.tab);
                }
                break;
            }
            case "blackKeyword": {
                this.addBlackWords(request.keyword);
                break;
            }


            case "isBlack": {
                let url = request.url;
                sendResponse(this.isBlackSite(url));
                break;
            }
            case "keywords": {
                let keywords = request.value,
                    url = request.url;
                request.tabId = sender.tab.id;

                if (this.isWhiteSite(url) || keywords.length === 0) {
                    return;
                }

                if (settings.options.filters.$block == 1) {
                    try {
                        keywords += this.blackWords.toString();
                    } catch (ex) {
                    }
                }
                let matching = utils.filterItem(api.controller.adult, "words", keywords, true);

                if (matching.value.length > 0) {
                    this.matchingWords = this.matchingWords.concat(matching.value);
                    this.matchingWords = this.matchingWords.unique();
                }
                if (this.matchingWords.length > 1) {
                    this.blockSite(request);
                }
                break;
            }


            case "blockSite": {
                let url = request.url;
                request.tabId = sender.tab.id;
                if (this.isWhiteSite(url)) {
                    return;
                }
                this.blockSite(request);
                break;
            }

            case "scanLink": {
                let isPorn = this.isPornSite(request);
                let isSuspicious = this.isSuspiciousDomain(request) || this.isSuspiciousWord(request.label);
                sendResponse({
                    message: "scanResponse",
                    linkIndex: request.linkIndex,
                    anchor: request.anchor,
                    isPorn: isPorn,
                    isSuspicious: isSuspicious
                });
            }
                break;
        }
    }

    onBeforeRequest(request) {
        let url = request.url,
            domain = utils.getDomain(url);

        if (settings.options.forcesafe.youtube === 1 && domain.indexOf("youtube.com") !== -1) {
            chrome.cookies.getAll({url: "http://*.youtube.com"}, this.checkCookies.bind(this));
        }
    }

    onBeforeNavigate(request) {
        this.matchingWords = [];
        let url = request.url;
        if (this.isPornSite(request) || url.indexOf(api.blockHost) !== -1) {
            this.blockSite(request, "native");
        }
        if (this.isBlackSite(url)) {
            this.blockSite(request, "user");
        }
    }

    getParameterByName(name, url) {
        if (!url) url = window.location.href;
        name = name.replace(/[\[\]]/g, '\\$&');
        var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
            results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return '';
        return decodeURIComponent(results[2].replace(/\+/g, ' '));
    }

    onCommitted(request) {
        let url = request.url;
        if (url.indexOf('chrome.google.com') != -1) {
            return false;
        }

        if (url.indexOf('chrome-extension://') != -1) {
            return false;
        }


        if (this.isPornSite(request) || url.indexOf(api.blockHost) !== -1) {
            this.blockSite(request, "native");
        }


        if (this.isBlackSite(url)) {
            this.blockSite(request, "user");
        }
        let tabId = request.tabId;

        if (!api.checkUrl(url))
            return false;


        let domain = utils.getDomain(url),
            hook = url.indexOf("?") !== -1 || url.indexOf("#") !== -1 ? "&" : "?",
            modify = false;

        return false;

         /*if (settings.options.forcesafe.google === 1 && domain.indexOf("google") !== -1) {
            if (url.indexOf("tbm=isch") !== -1) {
                modify = true;
            } else if (url.indexOf("tbm=vid") !== -1) {
                modify = true;
            } else if (url.match(/(?=.search\?)(?=.*q=)/g)) {
                modify = true;
            } else {
                return {cancel: false};
            }
            if (modify) {
                let safe = this.getParameterByName('safe', url)
                if(safe != 'active'){
                    let newurl = url + hook + "safe=active";
                    newurl = newurl.replace("sa=X", "");
                    console.log('modify')
                    chrome.tabs.update(tabId, {url: newurl});
                }
            }


            return {cancel: false};
        }*/
        if (settings.options.forcesafe.yahoo === 1 && domain.indexOf("yahoo") !== -1) {
            if (url.indexOf("google.") !== -1) {
                return {cancel: false};
            }
            if (url.indexOf("ads") === -1 && url.indexOf("p=") === -1 && url.indexOf("vm=r") === -1) {
                return {cancel: false};
            }
            if (url.indexOf("images.search.yahoo.") !== -1) {
                if (url.indexOf("view?") === -1 && url.indexOf("view;_ylt") === -1) {
                    modify = true;
                }
            } else if (url.indexOf("video.search.yahoo.") !== -1) {
                if (url.indexOf("action=view") === -1 && url.indexOf("viewer?" === -1)) {
                    modify = true;
                }
            } else if (url.indexOf("search.yahoo.com") !== -1 && (url.indexOf("search;") !== -1 || url.indexOf("search?") !== -1)) {
                modify = true;
            }
            if (modify) {
                if (url.indexOf("vm=r") === -1) {
                    let newurl = url + hook + "vm=r";
                    chrome.tabs.update(tabId, {
                        url: newurl
                    });
                }
            }
        }
        if (settings.options.forcesafe.bing === 1 && domain.indexOf("bing") !== -1) {
            if ((url.indexOf("bing.com/search") != -1 || url.indexOf("bing.com/images") != -1 || url.indexOf("bing.com/videos") !== -1 || url.indexOf("bing.com/settings") !== -1) && url.indexOf("/images/landing/settings") === -1 && url.indexOf("adlt=strict") === -1) {
                hook = url.indexOf("?") !== -1 ? "&" : "?";
                let newurl = url + hook + "adlt=strict";
                url = newurl.replace("is_child=0", "is_child=1");
                chrome.tabs.update(tabId, {
                    url: newurl
                });
            }
        }
    }

    onHeadersReceived(details) {
        let headers = details.responseHeaders,
            blocked = false,
            domain = utils.getDomain(details.url);

        if (settings.options.forcesafe.youtube === 1) {
            if (domain.indexOf("youtube.com") !== -1) {
                chrome.cookies.getAll({url: "http://*.youtube.com"}, this.checkCookies);
            }
        }

        if (domain.indexOf("maps.gstatic.com") === -1 && domain.indexOf("google") === -1 && domain.indexOf("ggpht.com") === -1) {
            for (let i = 0; i < headers.length; i++) {
                if (headers[i].name.toLowerCase() == "rating") {
                    if (headers[i].value.indexOf("RTA" !== -1)) {
                        if (this.isWhiteSite(details.url)) {
                            return;
                        }
                        blocked = true;
                        break;
                    }
                }
            }
            if (blocked) {
                this.blockSite(details);
            }
            return {responseHeaders: details.responseHeaders};
        }
    }

    onTabCreated(tab) {
        this.activeTabId = tab.id;
    }

    onSelectionChanged(tabId, changeInfo) {
        this.activeTabId = tabId;
    }

    work() {

        chrome.storage.local.get('white', function (result) {
            if (typeof result.white !== "undefined") {
                this.white = result.white;
            }
        });

        chrome.storage.local.get("black", function (result) {
            if (typeof result.black !== "undefined") {
                this.black = result.black;
            }
        }.bind(this));

        chrome.storage.local.get("blackwords", function (result) {
            if (typeof result.blackwords !== "undefined") {
                this.blackWords = result.blackwords;
            }
        }.bind(this));

        chrome.extension.onMessage.addListener(this.onMessage.bind(this));

        chrome.webRequest.onBeforeRequest.addListener(this.onBeforeRequest.bind(this), {
            urls: ["<all_urls>"]
        }, ["blocking"]);
        chrome.webNavigation.onBeforeNavigate.addListener(this.onBeforeNavigate.bind(this));
        chrome.webNavigation.onCommitted.addListener(this.onCommitted.bind(this));
        chrome.webRequest.onHeadersReceived.addListener(this.onHeadersReceived.bind(this), {
            urls: []
        }, ["responseHeaders", "blocking"]);
        chrome.tabs.onCreated.addListener(this.onTabCreated.bind(this));
        chrome.tabs.onSelectionChanged.addListener(this.onSelectionChanged.bind(this));
    }
}

const adult = new Adult();

$(document).ready(function () {
    adult.work()
});
