/*! Parental Control V2.18 */
class bg{
    constructor(){
        this.getParam();
        this.contextMenu = 1;
        this.icon = 0;
        chrome.storage.onChanged.addListener(function () {
            this.getParam()
        }.bind(this));
    }
    getParam(){
        chrome.storage.local.get('options', function (e) {
                let i = e.options.account.hide_icon;
                this.icon = i;
                this.changeIcon();

                this.contextMenu = e.options.account.hide_context_menu;
                this.initContextMenu();

        }.bind(this));
    }
    changeIcon(){
        if(this.icon == 1){
            chrome.browserAction.setIcon({
                path: "assets/icons/none.png"});
        } else {
            chrome.browserAction.setIcon({path: "assets/icons/icon-128.png"});
        }
    }
    initContextMenu(){
        if(this.contextMenu == 0){
            chrome.contextMenus.create({
                title: chrome.i18n.getMessage("context_menu_block_this_site"),
                onclick: initialize.blockSite.bind(this)
            });

            chrome.contextMenus.create({
                title: chrome.i18n.getMessage("context_menu_add_this_site_to_trust_list"),
                onclick: initialize.allowSite.bind(this)
            });
        } else {
            chrome.contextMenus.removeAll(function() {
                console.log("contextMenus.removeAll callback");
            });
        }
    }
}
(function () {
    new bg();
})();