/*! Parental Control V2.18 */
class Initialize {
    constructor() {
    }

    getDomain(url) {
        if (url === null)
            return url;
        return this.parseUrl(url).hostname
    }

    guid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 65536).toString(16).substring(1);
        }

        return s4() + s4() + "-" + s4() + "-" + s4() + "-" + s4() + "-" + s4() + s4() + s4();
    }

    blockSite() {
        chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
            let tab = tabs[0],
                url = tab.url,
                domain = this.getDomain(url),
                optionsPage = chrome.extension.getURL("options.html?block=1&domain=" + domain);
            chrome.tabs.create({url: optionsPage, active: true});
        }.bind(this));
    }

    parseUrl(url) {
        let a = document.createElement('a');
        a.href = url;
        return a;
    }

    allowSite() {
        chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
            let tab = tabs[0],
                url = tab.url,
                domain = this.getDomain(url),
                optionsPage = chrome.extension.getURL("options.html?allow=1&domain=" + domain);
            chrome.tabs.create({
                url: optionsPage,
                active: true
            });
        }.bind(this));
    }

    init() {
    }
}

const initialize = new Initialize();

document.addEventListener("DOMContentLoaded", function () {
    initialize.init();
});