/*! Parental Control V2.18 */
class Opt {
    constructor() {
        this.tabId = 4;
        this.auth = false;

        let block = this.getUrlParameter("block"),
            allow = this.getUrlParameter("allow"),
            adult = this.getUrlParameter("adult"),
            message = this.getUrlParameter("message"),
            domain = this.getUrlParameter("domain");
        if (message == 1) {
            this.tabId = 3;
            $('#tabpages').tabs({active: this.tabId});
        } else if (adult == 1) {
            this.tabId = 2;
            $('#tabpages').tabs({active: this.tabId});
        } else if (allow == 1) {
            $('#search-trust').val(domain);
            this.tabId = 1;
            $('#tabpages').tabs({active: this.tabId});
        } else if (block == 1) {
            this.tabId = 0;
            $('#block').val(domain);
            $('#tabpages').tabs({active: this.tabId});
        } else {
            this.tabId = 3;
            $('#tabpages').tabs({active: this.tabId});
        }
        this.translate();

        chrome.storage.onChanged.addListener(function (changes, namespace) {
            chrome.storage.local.get(null, function (items) {
                this.options = items.options;
                this.white = items.white ? items.white : [];
                this.black = items.black ? items.black : [];
                this.globalConf = items;
                this.isAuth();
                this.getLists();

            }.bind(this))
        }.bind(this));

        chrome.storage.local.get(null, function (items) {
            this.options = items.options;
            this.white = items.white ? items.white : [];
            this.black = items.black ? items.black : [];
            this.blackwords = items.blackwords ? items.blackwords : [];
            this.globalConf = items;
            this.isAuth();

        }.bind(this));

        this.helpUrl = "https://parentalcontrol.site/help.html";
        this.paymentlink = "https://parentalcontrol.site/donate.html";
        this.privacypolicylink = "https://parentalcontrol.site/privacypolicy.html";
        $("#version_number").html(chrome.i18n.getMessage('version_number') + " " + chrome.runtime.getManifest().version);

    }

    getUrlParameter(param) {
        let sPageURL = decodeURIComponent(window.location.search.substring(1)), sURLVariables = sPageURL.split("&"),
            sParameterName, i;
        for (i = 0; i < sURLVariables.length; i++) {
            sParameterName = sURLVariables[i].split("=");
            if (sParameterName[0] === param) {
                return sParameterName[1] === undefined ? true : sParameterName[1];
            }
        }
    }
    addEntry(cat, website) {
        if ($(`[data-${cat}='${website}']`).length === 0) {
            let inject = `<div class="cat_${cat}" data-url="${website}"><div class="website-entry">
                <img style="width:16px;height:16px;" src="http://www.google.com/s2/favicons?domain=${website}"/>
                <span class="sitename" style="padding-left:10px;">${website}</span>
                <img class="website-image" src="/assets/images/ic-delete.png" cat="${cat}" data-${cat}="${website}" data="${website}"/>
                </div>
            </div>`;
            $(`#${cat}-website`).append(inject);
        }
    }

    getLists() {
        $(".cat_trust").remove();
        $(".cat_block").remove();

        for (let i = 0; i < this.white.length; i++) {
            this.addEntry("trust", this.white[i]);
        }
        for (let i = 0; i < this.black.length; i++) {
            this.addEntry("block", this.black[i]);
        }

        $(".website-image").on("click", function (e) {
            console.log("website-image");
            let url = $(this).attr("data"),
                cat = $(this).attr("cat");
            chrome.extension.sendMessage({message: "removeFromList", cat: cat, url: url});
            $(`.cat_${cat}[data-url="${url}"]`).remove();
        });
    }

    accessLevel() {
        $("#passPwdLabel").hide();
        this.accessTrue();
        this.initUi();
        this.load();
    }

    isAuth() {
        if (typeof this.globalConf.passcode != "undefined" && this.globalConf.passcode !== "") {

            $("#password-set-label").html(chrome.i18n.getMessage("password_is_set"));

            if (this.auth == false) {
                $("#password-set-label").hide();
                $("#list-pwd-options").hide();
                $(".ui-tabs-nav").hide();
                $('#tabpages').tabs({active: 3});
                $('#set-pwd-button').html(chrome.i18n.getMessage("set_pwd_button_login"));
                $("#passPwdLabel").html(chrome.i18n.getMessage("please_pass"));

                $('#set-pwd-button').unbind().on('click', function (e) {
                    let pwd = $("#pwd").val();
                    let encrypted = this.globalConf.passcode,
                        bytes = CryptoJS.AES.decrypt(encrypted.toString(), "YHGFTJGF7Ls"),
                        plain = bytes.toString(CryptoJS.enc.Utf8);

                    if (plain == pwd) {
                        this.auth = true;
                        $.notify(chrome.i18n.getMessage("notify_allow_access"), "success");
                        this.accessLevel();
                    } else {
                        $.notify(chrome.i18n.getMessage("notify_wrong_access"), "error");
                        this.auth = false;
                    }
                }.bind(this));
                return;
            } else {
                $('#set-pwd-button').html(chrome.i18n.getMessage("set_password"));
                $("#passPwdLabel").hide();
            }
        } else {
            this.accessLevel();
        }
    }
    setAdultCheckboxState() {
        $("#google").attr("checked", this.google === 1);
        $("#yahoo").attr("checked", this.yahoo === 1);
        $("#bing").attr("checked", this.bing === 1);
        $("#ads").attr("checked", this.ads === 1);
        $("#suspicious").attr("checked", this.suspicious === 1);
        $("#google_safe").attr("checked", this.google_safe === 1);
        $("#yahoo_safe").attr("checked", this.yahoo_safe === 1);
        $("#bing_safe").attr("checked", this.bing_safe === 1);
        $("#youtube_safe").attr("checked", this.youtube_safe === 1);
        $("#pwd-block").attr("checked", this.pwd_block === 1);
        $("#pwd-trust").attr("checked", this.pwd_trust === 1);
        $("#hide_icon").attr("checked", this.options.account.hide_icon === 1);
        $("#hide_context_menu").attr("checked", this.options.account.hide_context_menu === 1);
    }

    accessTrue() {
        $("#password-set-label").show();
        $("#list-pwd-options").show();
        $(".ui-tabs-nav").show()
        $("#set-pwd-button").html(chrome.i18n.getMessage("change_password"))
    }

    load() {
        this.master = this.options.filters.$master;
        this.adult = this.options.filters.$adult;
        this.ads = this.options.filters.$ads;
        this.block = this.options.filters.$block;
        this.trust = this.options.filters.$trust;

        this.google = this.options.search.google;
        this.yahoo = this.options.search.yahoo;
        this.bing = this.options.search.bing;
        this.suspicious = this.options.search.suspicious;
        this.google_safe = this.options.forcesafe.google;
        this.yahoo_safe = this.options.forcesafe.yahoo;
        this.bing_safe = this.options.forcesafe.bing;
        this.youtube_safe = this.options.forcesafe.youtube;

        this.pwd_require = this.options.account.require;
        this.pwd_block = this.options.account.block;
        this.pwd_trust = this.options.account.trust;
        this.style = this.options.account.style;

        if (this.style == 1) {
            $("#style1").attr("checked", "checked");
        }
        if (this.style == 2) {
            $("#style2").attr("checked", "checked");
        }
        if (this.style == 3) {
            $("#style3").attr("checked", "checked");
        }

        if (this.pwd_require === 1) {
            $("#pwd-require").attr("checked", "checked");
        }

        if (this.master === 1) {
            $("#slider-master").attr("checked", "checked");
        }
        if (this.adult === 1) {
            $("#slider-adult").attr('checked', 'checked');
        }

        if (this.block === 1) {
            $("#slider-block").attr('checked', 'checked');
        }
        if (this.trust === 1) {
            $("#slider-trust").attr('checked', 'checked');
        }
        this.setAdultCheckboxState();

        setTimeout(this.getLists.bind(this), 300);
    }

    initUi() {
        $("#search-trust-button").unbind().on('click', function (e) {
            chrome.extension.sendMessage({message: "addToWhiteList", url: $("#search-trust").val()});
            $.notify(chrome.i18n.getMessage("notify_success_add_site_to_white_list"), "success");
        });

        $("#block-button").unbind().on('click', function (e) {
            chrome.extension.sendMessage({
                message: "addToBlackList",
                url: $("#block").val()
            });
            $.notify(chrome.i18n.getMessage("notify_success_add_site_to_black_list"), "success");
        });
        $("#set-pwd-button").unbind().on("click", function (e) {
            let pwd = $("#pwd").val();
            if (pwd.length === 0) {
                $.notify(chrome.i18n.getMessage("notify_empty_pass"), "error");
                $("#pwd").focus();
                return false;
            }
            chrome.runtime.sendMessage({message: "setPassword", value: pwd}, function (response) {
                $(".set-pwd").val("");
                $("#password-set-label").html("Password has been set");
                $("#password-set-label").css("color", "#1ec713");
                $(".set-pwd-button").val("Ste a new Password");
            });
        });

        $("#ads").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.filters.$ads = 1;
            } else {
                this.options.filters.$ads = 0;
            }
            this.save();
        }.bind(this));

        $("#suspicious").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.search.suspicious = 1;
            } else {
                this.options.search.suspicious = 0;
            }
            this.save();
        }.bind(this));

        $("#google_safe").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.forcesafe.google = 1;
            } else {
                this.options.forcesafe.google = 0;
            }
            this.save();
        }.bind(this));

        $("#yahoo_safe").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.forcesafe.yahoo = 1;
            } else {
                this.options.forcesafe.yahoo = 0;
            }
            this.save();
        }.bind(this));

        $("#hide_icon").on("change", function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.hide_icon = 1;
            } else {
                this.options.account.hide_icon = 0;
            }
            this.save();
        }.bind(this));

        $("#hide_context_menu").on("change", function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.hide_context_menu = 1;
            } else {
                this.options.account.hide_context_menu = 0;
            }
            this.save();
        }.bind(this));


        $("#bing_safe").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.forcesafe.bing = 1;
            } else {
                this.options.forcesafe.bing = 0;
            }
            this.save();
        }.bind(this));

        $("#youtube_safe").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.forcesafe.youtube = 1;
            } else {
                this.options.forcesafe.youtube = 0;
            }
            this.save();
        }.bind(this));

        $("#google").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.search.google = 1;
            } else {
                this.options.search.google = 0;
            }
            this.save();
        }.bind(this));

        $("#yahoo").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.search.yahoo = 1;
            } else {
                this.options.search.yahoo = 0;
            }
            this.save();
        }.bind(this));

        $("#bing").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.search.bing = 1;
            } else {
                this.options.search.bing = 0;
            }
            this.save();
        }.bind(this));


        $("#pwd-require").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.require = 1;
            } else {
                this.options.account.require = 0;
            }
            this.save();
        }.bind(this));

        $("#slider-block").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.filters.$block = 1;
            } else {
                this.options.filters.$block = 0;
            }
            this.save();
        }.bind(this));

        $("#slider-adult").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.filters.$adult = 1;
            } else {
                this.options.filters.$adult = 0;
            }
            this.save();
        }.bind(this));

        $("#slider-trust").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.filters.$trust = 1;
            } else {
                this.options.filters.$trust = 0;
            }
            this.save();

        }.bind(this));

        $("#slider-master").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.filters.$master = 1;
            } else {
                this.options.filters.$master = 0;
            }
            this.save();
        }.bind(this))


        $("#pwd-block").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.block = 1;
            } else {
                this.options.account.block = 0;
            }
            this.save();
        }.bind(this));


        $("#pwd-trust").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.trust = 1;
            } else {
                this.options.account.trust = 0;
            }
            this.save();
        }.bind(this));

        $("#style1").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.style = 1;
            }
            this.save();
        }.bind(this));


        $("#style2").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.style = 2;
            }
            this.save();
        }.bind(this));

        $("#style3").on('change', function (e) {
            if ($(e.target).is(':checked')) {
                this.options.account.style = 3;
            }
            this.save();
        }.bind(this))

    }


    save(isBackup) {
        chrome.runtime.sendMessage({
            message: isBackup ? "saveBackupSettings" : "saveSettings",
            options: this.options
        });
    }

    translate() {
        $("[data-i18n]").each(function (index) {
            $(this).html(chrome.i18n.getMessage($(this).data("i18n")));
        });

        $("[data-i18n-placeholder]").each(function (index) {
            $(this).attr("placeholder", chrome.i18n.getMessage($(this).attr("placeholder")));
        })


    }
}

$(function () {
    new Opt();
});